{$APPTYPE CONSOLE}
{$B-,R-,O+}
{$MAXSTACKSIZE 100000000}
const
 maxn=50000;
 maxm=maxn;
 maxedge=2*maxm;
type
 tlist=record
  v:word;
  next,rev:longint;
 end;
 pair=record
  f,g:word;
 end;
var
 fi,fo:text;
 n,modul,i:word;
 p:array[1..maxn] of longint;
 t:array[1..maxedge] of tlist;
 h:longint;
 aa,bb:longint;
 used:array[1..maxn] of boolean;
 usede:array[1..maxedge] of boolean;
 q:array[1..maxn] of byte;
 parent:array[1..maxn] of word;
 c:array[0..maxn] of word;
 ans,cur:word;
 y:pair;
 edge:longint;
procedure pushlist(v1,v2:word;rev:longint);
begin
 inc(h);
 t[h].v:=v2;
 t[h].next:=p[v1];
 t[h].rev:=rev;
 p[v1]:=h;
end;
procedure dfs_cycle(ver:word);
var
 tek:longint;
begin
 q[ver]:=1;
 tek:=p[ver];
 while(tek<>0)do
  begin
   if(t[tek].v<>parent[ver])then
    begin
     if(q[t[tek].v]=0)then
      begin
       parent[t[tek].v]:=ver;
       dfs_cycle(t[tek].v);
      end else
     if(q[t[tek].v]=1)then
      begin
       inc(c[0]);
       c[c[0]]:=ver;
       edge:=tek;
       while(c[c[0]]<>t[tek].v)do
        begin
         inc(c[0]);
         c[c[0]]:=parent[c[c[0]-1]];
        end;
      end;
    end;
   tek:=t[tek].next;
  end;
 q[ver]:=2;
end;
function calc(ver:word):pair;
var
 tek:longint;
 x:pair;
begin
 used[ver]:=true;
 x.f:=1;
 x.g:=1;
 tek:=p[ver];
 while(tek<>0)do
  begin
   if(not used[t[tek].v])and(not usede[tek])and(not usede[t[tek].rev])then
    begin
     y:=calc(t[tek].v);
     x.f:=(longword(x.g)*y.g+longword(x.f)*y.f)mod modul;
     x.g:=(longword(x.g)*y.f)mod modul;
    end;
   tek:=t[tek].next;
  end;
 calc:=x;
end;
begin
 assign(fi,'museum.dat');
 assign(fo,'museum.sol');
 reset(fi);
 rewrite(fo);
 readln(fi,n,modul);
 h:=0;
 for i:=1 to n do
  begin
   readln(fi,aa,bb);
   pushlist(aa,bb,h+2);
   pushlist(bb,aa,h);
  end;
 fillchar(q,sizeof(q),0);
 fillchar(parent,sizeof(parent),0);
 c[0]:=0;
 dfs_cycle(1);
 ans:=0;
 //1 - using cycle
 fillchar(used,sizeof(used),0);
 fillchar(usede,sizeof(usede),0);
 for i:=1 to c[0] do
  used[c[i]]:=true;
 cur:=1;
 for i:=1 to n do
  if(not used[i])then
   cur:=(longword(cur)*calc(i).f)mod modul;
 ans:=(ans+2*cur) mod modul;
 //2 - using edge
 fillchar(used,sizeof(used),0);
 fillchar(usede,sizeof(usede),0);
 used[c[1]]:=true;
 used[c[c[0]]]:=true;
 cur:=1;
 for i:=1 to n do
  if(not used[i])then
   cur:=(longword(cur)*calc(i).f)mod modul;
 ans:=(ans+cur) mod modul;
 //3 - not using edge
 fillchar(used,sizeof(used),0);
 fillchar(usede,sizeof(usede),0);
 usede[edge]:=true;
 usede[t[edge].rev]:=true;
 cur:=1;
 for i:=1 to n do
  if(not used[i])then
   cur:=(longword(cur)*calc(i).f)mod modul;
 ans:=(ans+cur) mod modul;
 //end
 writeln(fo,ans);
 close(fi);
 close(fo);
end.